'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Plugin abstract class.
 * Every plugin should implement this interface.
 * All plugins inside cst package should extend this class.
 */

var BasePlugin = function () {
  function BasePlugin() {
    (0, _classCallCheck3.default)(this, BasePlugin);
  }

  (0, _createClass3.default)(BasePlugin, [{
    key: 'createApiForProgram',


    /**
     * Returns plugin API.
     * Plugin's API will be accessible using `program.plugins.<pluginName>`.
     */
    value: function createApiForProgram(program) {}
  }, {
    key: 'pluginName',

    /**
     * Returns plugin name.
     * Plugin's API will be accessible using `program.plugins.<pluginName>`.
     */
    get: function get() {
      return 'basePlugin';
    }
  }]);
  return BasePlugin;
}();

exports.default = BasePlugin;