'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Reference = function () {
    function Reference(_ref) {
        var node = _ref.node;
        var scope = _ref.scope;
        var read = _ref.read;
        var write = _ref.write;
        var type = _ref.type;
        (0, _classCallCheck3.default)(this, Reference);

        this._node = node;
        this._scope = scope;
        this._read = read;
        this._write = write;
        this._type = type;
    }

    (0, _createClass3.default)(Reference, [{
        key: 'node',
        get: function get() {
            return this._node;
        }
    }, {
        key: 'scope',
        get: function get() {
            return this._scope;
        }
    }, {
        key: 'variable',
        get: function get() {
            return this._variable;
        }
    }, {
        key: 'isRead',
        get: function get() {
            return this._read;
        }
    }, {
        key: 'isWrite',
        get: function get() {
            return this._write;
        }
    }, {
        key: 'isReadOnly',
        get: function get() {
            return this._read && !this._write;
        }
    }, {
        key: 'isWriteOnly',
        get: function get() {
            return !this._read && this._write;
        }
    }, {
        key: 'isReadWrite',
        get: function get() {
            return this._read && this._write;
        }
    }]);
    return Reference;
}();

exports.default = Reference;